<?php

declare(strict_types=1);

namespace App\Controller\Api\v1;

use App\Controller\AbstractController;
use App\Model\Arts\OrderModel;
use App\Request\Api\v1\System\CancelRequest;
use App\Utils\AppResult;
use Hyperf\DbConnection\Db;

/**
 * Demo
 * 管理系统操作
 */
class SystemController extends AbstractController
{
    // 日志模块名称
    const LOG_MODULE = 'v1/SystemController';

    /**
     * 示例接口
     *
     * @param CancelRequest $request 校验参数注入类
     * @return string
     */
    public function cancel(CancelRequest $request)
    {
        $params = $request->validated();// 获取校验通过的参数
        Db::beginTransaction();
        $model = new OrderModel();
        if (!$model->cancel(order_no: $params['order_no'], reason: $params['reason'], is_system: 1)) {
            Db::rollBack();
            return AppResult::error($model->getMessage());
        }
        Db::commit();

        return AppResult::success($model->getMessage());
    }
}