<?php

declare(strict_types=1);

namespace App\Request\Api\v1\Order;

use Hyperf\Validation\Request\FormRequest;

class TailwindDriverRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     */
    public function authorize(): bool
    {
        return true;
    }

    /**
     * Get the validation rules that apply to the request.
     */
    public function rules(): array
    {
        return [
            'point' => 'required|array',
            'page'  => 'required|integer',
            'size'  => 'required|integer',
        ];
    }

    /**
     * 表单请求后钩子
     * @param $validator
     */
    public function withValidator($validator)
    {
        $validator->after(function ($validator) {
            //获取参数
            $params = $this->validationData();

            if (!isset($params['point']) || (count($params['point']) < 1 || count($params['point']) > 2)) {
                return $validator->errors()->add('point', '起终点数据有误');
            }

            if (isset($params['point'])) {
                foreach ($params['point'] as $item) {
                    if (empty($item['address']) || empty($item['lng']) || empty($item['lat'])) {
                        return $validator->errors()->add('point', '起终点数据有误');
                    }
                }
            }

        });
    }
}
