<?php

namespace App\Utils\Control;

use Hyperf\HttpServer\Router\Dispatched;
use Psr\Http\Message\ServerRequestInterface;

class ActionUtil
{
    private static string $prefix = 'App\Controller\\';
    /**
     * 获取当前路由地址
     * @param ServerRequestInterface $request
     * @param string $project
     * @return array
     */
    public static function actions(ServerRequestInterface $request, string $project = 'Api'): array
    {
        $action     = $request->getAttribute(Dispatched::class)->handler->callback ?? [];
        $controller = str_replace(self::$prefix.$project . '\\', '', $action[0] ?? '');
        $controller = str_replace('\\', '/', $controller);
        if (!empty($action[1])) {
            $res['controller'] = $controller ?? 'CommonController';
            $res['action']     = $action[1];
        } else {
            $res['controller'] = 'CommonController';
            $res['action']     = 'common';
        }
        return $res;
    }

}